Index: reactapp/src/Pages/UserDashboard.js
===================================================================
--- reactapp/src/Pages/UserDashboard.js	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ reactapp/src/Pages/UserDashboard.js	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -27,4 +27,5 @@
 } from "../Components/Styled/Modal.style";
 import LoadingSpinner from "../Components/Styled/LoadingSpinner.style";
+import {findParentThread} from "../Util/findParentThread";
 
 function UserDashboard() {
@@ -33,4 +34,7 @@
   const [user, setUser] = useState(null);
   const [loadedUser, setLoadedUser] = useState(false);
+  const [authoredPosts, setAuthoredPosts] = useState(null);
+  const [loadedAuthoredPosts, setLoadedAuthoredPosts] = useState(false);
+
   const [fetchError, setFetchError] = useState(false);
 
@@ -45,6 +49,4 @@
   const [newPostContent, setNewPostContent] = useState("");
   const [newOpinionTargetProfessorId, setNewOpinionTargetProfessorId] = useState("");
-  const [newOpinionTargetProfessor, setNewOpinionTargetProfessor] = useState(null);
-  const [loadedNewProfessor,setLoadedNewProfessor] = useState(false);
   const [newParentPostId, setNewParentPostId] = useState("-1");
 
@@ -52,6 +54,5 @@
   const [newParentThreadId,setNewParentThreadId] = useState("-1");
   const [newTargetSubjectId, setNewTargetSubjectId] = useState("");
-  const [newTargetSubject, setNewTargetSubject] = useState(null);
-  const [loadedNewSubject, setLoadedNewSubject] = useState(null);
+
 
   const [markResolved, setMarkResolved] = useState(false);
@@ -83,5 +84,9 @@
   }, [reportForModal]);
 
-  const[loadingProf, setLoadingProf] = useState(false);
+  const [newOpinionTargetProfessor, setNewOpinionTargetProfessor] = useState(null);
+  const [loadedNewProfessor,setLoadedNewProfessor] = useState(false);
+  const [newProfessorRelatedOpinions, setNewProfessorRelatedOpinions] = useState(null);
+  const [loadedNewProfessorRelatedOpinions, setLoadedNewProfessorRelatedOpinions] = useState(false);
+  const [loadingProf, setLoadingProf] = useState(false);
 
   const handleNewTargetProfessorChange = async (e) => {
@@ -90,11 +95,22 @@
     if (newOpinionTargetProfessorId!=="") {
         try {
-          const response = await axios.get(`http://192.168.0.29:8080/public/professor/${newOpinionTargetProfessorId}`, {withCredentials: true});
-          let cyclicGraph = await response.data;
-          var jsogStructure = JSOG.encode(cyclicGraph);
-          cyclicGraph = JSOG.decode(jsogStructure);
-          setNewOpinionTargetProfessor(cyclicGraph);
-          setLoadedNewProfessor(true);
-          setLoadingProf(false);
+          Promise.all([fetch(`http://192.168.1.254:8080/public/professor/${newOpinionTargetProfessorId}`),
+            fetch(`http://192.168.1.254:8080/public/professor/${newOpinionTargetProfessorId}/relatedOpinions`)])
+              .then(([resNewOpinionTargetProfessor, resNewProfessorRelatedOpinions]) => Promise.all([resNewOpinionTargetProfessor.json(), resNewProfessorRelatedOpinions.json()]))
+              .then(([dataNewOpinionTargetProfessor, dataNewProfessorRelatedOpinions]) => {
+                let cyclicGraph1 = dataNewOpinionTargetProfessor;
+                var jsogStructure1 = JSOG.encode(cyclicGraph1);
+                cyclicGraph1 = JSOG.decode(jsogStructure1);
+                setNewOpinionTargetProfessor(cyclicGraph1);
+                setLoadedNewProfessor(true);
+
+                let cyclicGraph2 = dataNewProfessorRelatedOpinions;
+                var jsogStructure2 = JSOG.encode(cyclicGraph2);
+                cyclicGraph2 = JSOG.decode(jsogStructure2);
+                setNewProfessorRelatedOpinions(cyclicGraph2);
+                setLoadedNewProfessorRelatedOpinions(true);
+
+                setLoadingProf(false);
+              })
         } catch (error) {
           setFetchError(true);
@@ -103,5 +119,9 @@
   }
 
-  const[loadingSubj, setLoadingSubj] = useState(false);
+  const [newTargetSubject, setNewTargetSubject] = useState(null);
+  const [loadedNewSubject, setLoadedNewSubject] = useState(false);
+  const [newTargetSubjectThreads, setNewTargetSubjectThreads] = useState(null);
+  const [loadedNewSubjectThreads, setLoadedNewSubjectThreads] = useState(false);
+  const [loadingSubj, setLoadingSubj] = useState(false);
 
   const handleNewTargetSubjectChange = async (e) => {
@@ -110,32 +130,50 @@
     if (newTargetSubjectId!=="") {
       try {
-        const response = await axios.get(`http://192.168.0.29:8080/public/subject/${newTargetSubjectId}`, {withCredentials: true});
-        let cyclicGraph = await response.data;
-        var jsogStructure = JSOG.encode(cyclicGraph);
-        cyclicGraph = JSOG.decode(jsogStructure);
-        setNewTargetSubject(cyclicGraph);
-        setLoadedNewSubject(true);
-        setLoadingSubj(false);
-      } catch (error) {
-        setFetchError(true);
-      }
+        Promise.all([fetch(`http://192.168.1.254:8080/public/subject/${newTargetSubjectId}`),
+        fetch(`http://192.168.1.254:8080/public/subject/${newTargetSubjectId}/threads`)])
+            .then(([resNewTargetSubject, resNewTargetSubjectThreads]) => Promise.all([resNewTargetSubject.json(), resNewTargetSubjectThreads.json()]))
+            .then(([dataNewTargetSubject, dataNewTargetSubjectThreads]) => {
+              let cyclicGraph1 = dataNewTargetSubject;
+              var jsogStructure1 = JSOG.encode(cyclicGraph1);
+              cyclicGraph1 = JSOG.decode(jsogStructure1);
+              setNewTargetSubject(cyclicGraph1);
+              setLoadedNewSubject(true);
+
+              let cyclicGraph2 = dataNewTargetSubjectThreads;
+              var jsogStructure2 = JSOG.encode(cyclicGraph2);
+              cyclicGraph2 = JSOG.decode(jsogStructure2);
+              setNewTargetSubjectThreads(cyclicGraph2);
+              setLoadedNewSubjectThreads(true);
+
+              setLoadingSubj(false);
+            })
+        } catch (error) {
+            setFetchError(true);
+        }
     }
   }
 
   useEffect(() => {
-    const url1 = `http://192.168.0.29:8080/secure/currentUser`;
-    const url2 = `http://192.168.0.29:8080/secure/getAllPostReports`;
-
-    const fetchUser = async () => {
+    const fetchUser = () => {
       try {
         if(!loadedUser) {
-          const response = await axios.get(url1, {withCredentials: true});
-          let cyclicGraph = await response.data;
-          var jsogStructure = JSOG.encode(cyclicGraph);
-          cyclicGraph = JSOG.decode(jsogStructure);
-          setUser(cyclicGraph);
-          setLoadedUser(true);
+          Promise.all([axios.get(`http://192.168.1.254:8080/secure/currentUser`, {withCredentials:true}),
+            axios.get(`http://192.168.1.254:8080/secure/currentUser/posts`, {withCredentials:true})])
+              .then(([resUser, resAuthoredPosts]) => Promise.all([resUser.data, resAuthoredPosts.data]))
+              .then(([dataUser, dataAuthoredPosts]) => {
+                let cyclicGraph1 = dataUser;
+                let jsogStructure1 = JSOG.encode(cyclicGraph1);
+                cyclicGraph1 = JSOG.decode(jsogStructure1);
+                setUser(cyclicGraph1);
+                setLoadedUser(true);
+
+                let cyclicGraph2 = dataAuthoredPosts;
+                let jsogStructure2 = JSOG.encode(cyclicGraph2);
+                cyclicGraph2 = JSOG.decode(jsogStructure2);
+                setAuthoredPosts(cyclicGraph2);
+                setLoadedAuthoredPosts(true);
+              })
         }
-        if(user.userRole==='MODERATOR')fetchPostReports();
+        if(user.userRole==='MODERATOR') fetchPostReports();
       } catch (error) {
         setFetchError(true);
@@ -145,5 +183,5 @@
     const fetchPostReports = async () => {
       try {
-        const response = await axios.get(url2, {withCredentials: true});
+        const response = await axios.get(`http://192.168.1.254:8080/secure/getAllPostReports`, {withCredentials: true});
         var cyclicGraph = await response.data;
         var jsogStructure = JSOG.encode(cyclicGraph);
@@ -160,21 +198,9 @@
   }, [user]);
 
-  // useEffect(() => {
-  //   const timer = setTimeout(() => {
-  //     if (user === null) window.location.reload(); <---- :-)
-  //   }, 3000);
-  //   return () => clearTimeout(timer);
-  // }, []);
-
-  function findParentThread(post) {
-    if (post.parent === null) return post;
-    return findParentThread(post.parent);
-  }
-
   const handleEdit = async (e) => {
     e.preventDefault();
     try {
       if(reportForModal.post !== null && reportForModal.post.targetProfessor !== undefined) {
-        await axios(`http://192.168.0.29:8080/secure/updateOpinion/${reportForModal.post.postId}`,
+        await axios(`http://192.168.1.254:8080/secure/updateOpinion/${reportForModal.post.postId}`,
             {
               method: "put",
@@ -186,6 +212,10 @@
               withCredentials: true,
             })
+        await axios(`http://192.168.1.254:8080/secure/markReportResolved/${reportForModal.postReportId}/${markResolved ? `resolve` : `open`}`,{
+          method: "get",
+          withCredentials: true
+        })
       } else if(reportForModal.post !== null && reportForModal.post.targetProfessor === undefined) {
-        await axios(`http://192.168.0.29:8080/secure/updateThread/${reportForModal.post.postId}`,
+        await axios(`http://192.168.1.254:8080/secure/updateThread/${reportForModal.post.postId}`,
             {
               method: "put",
@@ -199,8 +229,8 @@
             })
       }
-        await axios(`http://192.168.0.29:8080/secure/markReportResolved/${reportForModal.postReportId}/${markResolved ? `resolve` : `open`}`,{
+      await axios(`http://192.168.1.254:8080/secure/markReportResolved/${reportForModal.postReportId}/${markResolved ? `resolve` : `open`}`,{
           method: "get",
           withCredentials: true
-        })
+      })
     } catch (error) {
       setFetchError(true);
@@ -213,5 +243,5 @@
     try {
       if(reportForModal.post !== null && reportForModal.post.targetProfessor !== undefined) {
-        var response = await axios(`http://192.168.0.29:8080/secure/updateOpinion/${reportForModal.post.postId}`,
+        var response = await axios(`http://192.168.1.254:8080/secure/updateOpinion/${reportForModal.post.postId}`,
             {
               method: "put",
@@ -223,6 +253,10 @@
               withCredentials: true,
             })
+        await axios(`http://192.168.1.254:8080/secure/markReportResolved/${reportForModal.postReportId}/${markResolved ? `resolve` : `open`}`,{
+          method: "get",
+          withCredentials: true
+        })
       } else if(reportForModal.post !== null && reportForModal.post.targetProfessor === undefined) {
-        var response = await axios(`http://192.168.0.29:8080/secure/updateThread/${reportForModal.post.postId}`,
+        var response = await axios(`http://192.168.1.254:8080/secure/updateThread/${reportForModal.post.postId}`,
             {
               method: "put",
@@ -236,5 +270,5 @@
             })
       }
-      await axios(`http://192.168.0.29:8080/secure/markReportResolved/${reportForModal.postReportId}/${markResolved ? `resolve` : `open`}`,{
+      await axios(`http://192.168.1.254:8080/secure/markReportResolved/${reportForModal.postReportId}/${markResolved ? `resolve` : `open`}`,{
         method: "get",
         withCredentials: true
@@ -251,5 +285,5 @@
     try {
       if(reportForModal.post !== null && reportForModal.post.targetProfessor !== undefined) {
-        await axios(`http://192.168.0.29:8080/secure/deleteOpinion/${reportForModal.post.postId}`,
+        await axios(`http://192.168.1.254:8080/secure/deleteOpinion/${reportForModal.post.postId}`,
             {
               method: "delete",
@@ -258,5 +292,5 @@
         window.location.reload();
       } else if(reportForModal.post !== null && reportForModal.post.targetProfessor === undefined) {
-        await axios(`http://192.168.0.29:8080/secure/deleteThread/${reportForModal.post.postId}`,
+        await axios(`http://192.168.1.254:8080/secure/deleteThread/${reportForModal.post.postId}`,
             {
               method: "delete",
@@ -312,10 +346,10 @@
       })}
       </EntityUl>
-      {user.authoredPosts.length > 0 ? (
+      {authoredPosts.length > 0 ? (
         <h3 style={{ marginBottom: "10px", marginTop:"30px" }}>Ваши мислења:</h3>
       ) : (
         <h3 style={{ marginBottom: "10px" }}>Немате објавени мислења</h3>
       )}
-      {user.authoredPosts.map((post) => {
+      {authoredPosts.map((post) => {
         return (
           <div key={post.postId}>
@@ -527,5 +561,4 @@
                                     во која треба да биде преместено мислењето:</p>
                                     <div style={{marginTop:"15px"}}>
-                                      <label>
                                         <ModalInput
                                             value={newOpinionTargetProfessorId}
@@ -542,16 +575,16 @@
                                         <select value={newParentPostId} onChange={e => setNewParentPostId(e.target.value)} style={{width:"280px", display:"block", padding:"5px",marginBottom:"5px", fontFamily: "Roboto Mono, monospace"}}>
                                           <option value="-1">Постави како самостојно мислење</option>
-                                          {newOpinionTargetProfessor.relatedOpinions.filter((opinion)=>opinion.postId!==reportForModal.post.postId).map((opinion) => {
+                                          {newProfessorRelatedOpinions.filter((opinion)=>opinion.postId!==reportForModal.post.postId).map((opinion) => {
                                             return <option key={opinion.postId} value={opinion.postId}>{opinion.postId}</option>})
                                           }
                                         </select>}
                                         <br/>
-                                        <input
-                                            type="checkbox"
-                                            defaultChecked={reportForModal.resolved}
-                                            onChange={handleMarkResolved}
-                                        />
-                                        <span style={{marginLeft:"10px", fontWeight:"bold"}}>Означи како разрешено</span>
-                                      </label>
+                                        <label>
+                                          <input
+                                              type="checkbox"
+                                              onChange={handleMarkResolved}
+                                          />
+                                          <span style={{marginLeft:"10px", fontWeight:"bold"}}>Означи како разрешено</span>
+                                        </label>
                                     </div>
                                 {errMsg!=="" && <p style={{color:"red", display:"flex", justifyContent:"space-around"}}>{errMsg}</p>}
@@ -578,5 +611,5 @@
                                         <select value={newParentThreadId} onChange={e => setNewParentThreadId(e.target.value)} style={{width:"370px", display:"block", padding:"5px",marginBottom:"5px", fontFamily: "Roboto Mono, monospace"}}>
                                           <option value="-1">Постави како самостојно мислење (нова тема)</option>
-                                          {newTargetSubject.threads.filter((thread)=>thread.postId!==reportForModal.post.postId).map((thread) => {
+                                          {newTargetSubjectThreads.filter((thread)=>thread.postId!==reportForModal.post.postId).map((thread) => {
                                             return <option key={thread.postId} value={thread.postId}>{thread.postId}</option>})
                                           }
Index: reactapp/src/Util/findParentThread.js
===================================================================
--- reactapp/src/Util/findParentThread.js	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
+++ reactapp/src/Util/findParentThread.js	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -0,0 +1,4 @@
+export const findParentThread = (post) => {
+    if (post.parent === null) return post;
+    return findParentThread(post.parent);
+}
Index: reactapp/src/api/axios.js
===================================================================
--- reactapp/src/api/axios.js	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ reactapp/src/api/axios.js	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -2,4 +2,4 @@
 
 export default axios.create({
-  baseURL: "http://192.168.0.29:8080",
+  baseURL: "http://192.168.1.254:8080",
 });
Index: springapp/src/main/java/mk/profesori/springapp/Controller/PublicController.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Controller/PublicController.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Controller/PublicController.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,3 +1,8 @@
 package mk.profesori.springapp.Controller;
+
+import mk.profesori.springapp.Model.*;
+import mk.profesori.springapp.Service.MainService;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.web.bind.annotation.*;
 
 import java.util.Collections;
@@ -6,24 +11,7 @@
 import java.util.Optional;
 
-import org.springframework.beans.factory.annotation.Autowired;
-import org.springframework.web.bind.annotation.CrossOrigin;
-import org.springframework.web.bind.annotation.PathVariable;
-import org.springframework.web.bind.annotation.RequestMapping;
-import org.springframework.web.bind.annotation.RequestMethod;
-import org.springframework.web.bind.annotation.RequestParam;
-import org.springframework.web.bind.annotation.RestController;
-
-import mk.profesori.springapp.Model.City;
-import mk.profesori.springapp.Model.Faculty;
-import mk.profesori.springapp.Model.Professor;
-import mk.profesori.springapp.Model.StudyProgramme;
-import mk.profesori.springapp.Model.Subject;
-import mk.profesori.springapp.Model.University;
-import mk.profesori.springapp.Model._Thread;
-import mk.profesori.springapp.Service.MainService;
-
 @RestController
 @RequestMapping("/public")
-@CrossOrigin(origins = { "http://192.168.0.29:3000", "http://192.168.0.28:3000" })
+@CrossOrigin(origins = { "http://192.168.1.254:3000", "http://192.168.0.28:3000" })
 public class PublicController {
 
@@ -42,6 +30,11 @@
     @RequestMapping(value = "/professors/nameContains/{contained}", method = RequestMethod.GET)
     public List<Professor> getProfessorsByNameContains(@PathVariable String contained) {
-        return mainService.getProfessorsByNameContains(contained); // vrakja profesori sto sodrzat "contained" vo
-                                                                   // professorName
+        return mainService.getProfessorsByNameContains(contained); // vrakja profesori sto sodrzat "contained" vo imeto
+
+    }
+
+    @RequestMapping(value = "/subjects/nameContains/{contained}", method = RequestMethod.GET)
+    public List<Subject> getSubjectsByNameContains(@PathVariable String contained) {
+        return mainService.getSubjectsByNameContains(contained); // vrakja predmeti sto sodrzat "contained" vo imeto
     }
 
@@ -49,4 +42,9 @@
     public Professor getProfessorById(@PathVariable Long professorId) {
         return mainService.getProfessorById(professorId); // vrakja profesor spored id
+    }
+
+    @RequestMapping(value="/professor/{professorId}/relatedOpinions", method = RequestMethod.GET)
+    public List<Opinion> getRelatedOpinions(@PathVariable Long professorId) {
+        return mainService.getRelatedOpinions(professorId);
     }
 
@@ -105,4 +103,9 @@
     }
 
+    @RequestMapping(value = "/subjects", method = RequestMethod.GET)
+    public List<Subject> getSubjectsByStudyProgramme(@RequestParam Long studyProgrammeId) {
+        return mainService.getSubjectsByStudyProgramme(studyProgrammeId);
+    }
+
     @RequestMapping(value = "/thread/{postId}", method = RequestMethod.GET)
     public _Thread getThreadById(@PathVariable Long postId) {
@@ -119,3 +122,39 @@
         return Collections.singletonMap("sessionId", sessionId);
     }
+
+    @RequestMapping(value = "/latest10opinions", method = RequestMethod.GET)
+    public List<Opinion> latest10opinions() {
+        return mainService.getLatest10Opinions();
+    }
+
+    @RequestMapping(value = "/latest10threads", method = RequestMethod.GET)
+    public List<_Thread> latest10threads() {
+        return mainService.getLatest10Threads();
+    }
+
+    @RequestMapping(value = "/subject/{id}/threads")
+    public List<_Thread> getThreadsBySubject(@PathVariable Long id) {
+        return mainService.getThreadsBySubject(id);
+    }
+
+    @RequestMapping(value = "/university/{id}/sectionAndPostCount")
+    public List<String> getUniversitySectionCount(@PathVariable Long id) {
+        return mainService.getUniversitySectionAndPostCount();
+    }
+
+    @RequestMapping(value = "/faculty/{id}/opinionCountForEachProfessor")
+    public List<String> getOpinionCountForEachProfessorInFaculty(@PathVariable Long id) {
+        return mainService.getOpinionCountForEachProfessorInFaculty(id);
+    }
+
+    @RequestMapping(value = "/study_programme/{id}/threadCountForEachSubject")
+    public List<String> getThreadCountForEachSubjectInStudyProgramme(@PathVariable Long id) {
+        return mainService.getThreadCountForEachSubjectInStudyProgramme(id);
+    }
+
+    @RequestMapping(value = "/user/{id}")
+    public CustomUserDetails getPublicUserProfile(@PathVariable Long id) {
+        return mainService.getPublicUserProfile(id);
+    }
+
 }
Index: springapp/src/main/java/mk/profesori/springapp/Controller/SecureController.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Controller/SecureController.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Controller/SecureController.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -3,9 +3,10 @@
 import com.fasterxml.jackson.databind.node.ObjectNode;
 import mk.profesori.springapp.Model.CustomUserDetails;
+import mk.profesori.springapp.Model.Post;
 import mk.profesori.springapp.Model.PostReport;
 import mk.profesori.springapp.Model.UserRole;
 import mk.profesori.springapp.Service.CustomUserDetailsService;
-import mk.profesori.springapp.Service.DisallowedOperationException;
-import mk.profesori.springapp.Service.IncompatiblePostId;
+import mk.profesori.springapp.Service.Exception.DisallowedOperationException;
+import mk.profesori.springapp.Service.Exception.IncompatiblePostId;
 import mk.profesori.springapp.Service.MainService;
 import org.apache.tomcat.websocket.AuthenticationException;
@@ -17,8 +18,9 @@
 
 import java.util.List;
+import java.util.Set;
 
 @RestController
 @RequestMapping("/secure")
-@CrossOrigin(origins = { "http://192.168.0.29:3000", "http://192.168.0.28:3000" })
+@CrossOrigin(origins = { "http://192.168.1.254:3000", "http://192.168.0.28:3000" })
 public class SecureController {
 
@@ -77,4 +79,13 @@
         if (authentication != null && authentication.getPrincipal() instanceof CustomUserDetails currentUser) {
             return customUserDetailsService.loadUserByUsername(currentUser.getEmail());
+        }
+        return null;
+    }
+
+    @RequestMapping(value = "/currentUser/posts", method = RequestMethod.GET)
+    public Set<Post> getPostsByUser(@CurrentSecurityContext SecurityContext context) {
+        Authentication authentication = context.getAuthentication();
+        if (authentication != null && authentication.getPrincipal() instanceof CustomUserDetails currentUser) {
+            return mainService.getPostsByUser(currentUser.getEmail());
         }
         return null;
Index: springapp/src/main/java/mk/profesori/springapp/Model/City.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Model/City.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Model/City.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,21 +1,16 @@
 package mk.profesori.springapp.Model;
 
+import com.fasterxml.jackson.annotation.JsonIdentityInfo;
+import com.voodoodyne.jackson.jsog.JSOGGenerator;
+import lombok.Data;
+
+import javax.persistence.*;
 import java.util.HashSet;
 import java.util.Set;
 
-import javax.persistence.Column;
-import javax.persistence.Entity;
-import javax.persistence.GeneratedValue;
-import javax.persistence.GenerationType;
-import javax.persistence.Id;
-import javax.persistence.OneToMany;
-import javax.persistence.Table;
-
-import com.fasterxml.jackson.annotation.JsonIdentityInfo;
-import com.fasterxml.jackson.annotation.ObjectIdGenerators;
-
 @Entity
+@Data
 @Table(name = "city")
-@JsonIdentityInfo(generator = ObjectIdGenerators.PropertyGenerator.class, property = "cityId")
+@JsonIdentityInfo(generator = JSOGGenerator.class)
 public class City {
 
@@ -28,19 +23,7 @@
     private String cityName;
 
+    @Transient
     @OneToMany(mappedBy = "city")
     private Set<University> universities = new HashSet<>();
 
-    // getters
-    public Long getCityId() {
-        return cityId;
-    }
-
-    public String getCityName() {
-        return cityName;
-    }
-
-    public Set<University> getUniversities() {
-        return universities;
-    }
-
 }
Index: springapp/src/main/java/mk/profesori/springapp/Model/CustomUserDetails.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Model/CustomUserDetails.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Model/CustomUserDetails.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -2,4 +2,5 @@
 
 import com.fasterxml.jackson.annotation.JsonIdentityInfo;
+import com.fasterxml.jackson.annotation.JsonIgnore;
 import com.voodoodyne.jackson.jsog.JSOGGenerator;
 import lombok.EqualsAndHashCode;
@@ -31,19 +32,29 @@
     private String fullName;
     private String username;
+    @JsonIgnore
     private String email;
-    private String password; // TODO
+    @JsonIgnore
+    private String password;
+    /*  UseCases
+        го уредува својот кориснички профил
+        го верификува својот кориснички профил todo...
+    */
     @Enumerated(EnumType.STRING)
     private UserRole userRole;
     private Boolean locked = false;
     private Boolean enabled = false;
-    @OneToMany(mappedBy = "customUserDetails", fetch = FetchType.EAGER, orphanRemoval = true)
+    @Transient
+    @OneToMany(mappedBy = "customUserDetails", orphanRemoval = true)
     private Set<ConfirmationToken> confirmationTokens = new HashSet<>();
-    @OneToMany(mappedBy = "author", fetch = FetchType.EAGER, orphanRemoval = true)
+    @Transient
+    @OneToMany(mappedBy = "author", orphanRemoval = true)
     private Set<Post> authoredPosts = new HashSet<>();
     private Integer karma = 0;
 
+    @Transient
     @OneToMany(mappedBy = "user", cascade = CascadeType.ALL, orphanRemoval = true)
     private Set<PostVote> votes = new HashSet<>();
 
+    @Transient
     @OneToMany(mappedBy = "user", cascade = {CascadeType.PERSIST})
     private Set<PostReport> reportsSubmitted = new HashSet<>();
@@ -99,31 +110,7 @@
     }
 
-    public Set<Post> getAuthoredPosts() {
-        return this.authoredPosts;
-    }
-
-    public Integer getKarma() {
-        return this.karma;
-    }
-
-    public void setKarma(Integer karma) {
-        this.karma = karma;
-    }
-
     @Override
     public String toString() {
         return this.id.toString();
     }
-
-    public void setLocked(Boolean locked) {
-        this.locked = locked;
-    }
-
-    public Set<PostVote> getVotes() {
-        return votes;
-    }
-
-    public void setVotes(Set<PostVote> votes) {
-        this.votes = votes;
-    }
 }
Index: springapp/src/main/java/mk/profesori/springapp/Model/Faculty.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Model/Faculty.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Model/Faculty.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,21 +1,14 @@
 package mk.profesori.springapp.Model;
 
+import com.fasterxml.jackson.annotation.JsonIdentityInfo;
+import com.voodoodyne.jackson.jsog.JSOGGenerator;
+import lombok.Data;
+
+import javax.persistence.*;
 import java.util.HashSet;
 import java.util.Set;
 
-import javax.persistence.Column;
-import javax.persistence.Entity;
-import javax.persistence.GeneratedValue;
-import javax.persistence.GenerationType;
-import javax.persistence.Id;
-import javax.persistence.JoinColumn;
-import javax.persistence.ManyToOne;
-import javax.persistence.OneToMany;
-import javax.persistence.Table;
-
-import com.fasterxml.jackson.annotation.JsonIdentityInfo;
-import com.voodoodyne.jackson.jsog.JSOGGenerator;
-
 @Entity
+@Data
 @Table(name = "faculty")
 @JsonIdentityInfo(generator = JSOGGenerator.class)
@@ -34,30 +27,11 @@
     private University university;
 
+    @Transient
     @OneToMany(mappedBy = "faculty")
     private Set<Professor> professors = new HashSet<>();
 
+    @Transient
     @OneToMany(mappedBy = "faculty")
     private Set<StudyProgramme> studyProgrammes = new HashSet<>();
 
-    // getters
-    public Long getFacultyId() {
-        return facultyId;
-    }
-
-    public String getFacultyName() {
-        return facultyName;
-    }
-
-    public University getUniversity() {
-        return university;
-    }
-
-    public Set<Professor> getProfessors() {
-        return professors;
-    }
-
-    public Set<StudyProgramme> getStudyProgrammes() {
-        return studyProgrammes;
-    }
-
 }
Index: springapp/src/main/java/mk/profesori/springapp/Model/Opinion.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Model/Opinion.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Model/Opinion.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,6 +1,6 @@
 package mk.profesori.springapp.Model;
 
-import java.time.LocalDateTime;
-import java.util.List;
+import lombok.Data;
+import lombok.NoArgsConstructor;
 
 import javax.persistence.DiscriminatorValue;
@@ -8,8 +8,9 @@
 import javax.persistence.JoinColumn;
 import javax.persistence.ManyToOne;
-
-import lombok.NoArgsConstructor;
+import java.time.LocalDateTime;
+import java.util.List;
 
 @Entity
+@Data
 @DiscriminatorValue("opinion")
 @NoArgsConstructor
@@ -35,12 +36,3 @@
         this.targetProfessor = targetProfessor;
     }
-
-    // getters and setters
-    public Professor getTargetProfessor() {
-        return targetProfessor;
-    }
-    public void setTargetProfessor(Professor targetProfessor) {
-        this.targetProfessor = targetProfessor;
-    }
-
 }
